function $AdfToolbarPanel$$($peer$$72$$) {
  this.Init($peer$$72$$);
}
$goog$exportSymbol$$("AdfToolbarPanel", $AdfToolbarPanel$$);
$AdfObject$$.$createSubclass$($AdfToolbarPanel$$);
$AdfToolbarPanel$$.$InitClass$ = function $$AdfToolbarPanel$$$$InitClass$$() {
  this.$_TOOLBAR_CONTAINER_SUB_ID$ = "tbr";
  this.$_TOOLBAR_CONTAINER_PLACEHOLDER_SUB_ID$ = "tbrph";
};
$goog$exportSymbol$$("AdfToolbarPanel.InitClass", $AdfToolbarPanel$$.$InitClass$);
$AdfToolbarPanel$$.prototype.Init = function $$AdfToolbarPanel$$$$Init$($peer$$73$$) {
  $AdfToolbarPanel$$.$superclass$.Init.call(this);
  this.$_peer$ = $peer$$73$$;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfToolbarPanel.prototype.Init", {Init:$AdfToolbarPanel$$.prototype.Init});
$AdfToolbarPanel$$.prototype.$attach$ = function $$AdfToolbarPanel$$$$$attach$$($component$$614$$, $suggestionsPopup$$1$$) {
  var $toolbarContainer$$ = $AdfToolbarPanel$$.$_getToolbarContainer$($component$$614$$);
  $toolbarContainer$$ && ($suggestionsPopup$$1$$.appendChild($toolbarContainer$$), this.$_manageFocusCallback$ = this.$createCallback$(this.$_manageFocusInToolbarFacet$), $AdfAgent$$.$AGENT$.$addBubbleEventListener$($toolbarContainer$$, "keydown", this.$_manageFocusCallback$));
};
$AdfObject$$.$exportPrototypeSymbol$("AdfToolbarPanel.prototype.attach", {$attach$:$AdfToolbarPanel$$.prototype.$attach$});
$AdfToolbarPanel$$.prototype.detach = function $$AdfToolbarPanel$$$$detach$($component$$615_toolbarContainer$$1$$) {
  var $toolbarPlaceholder$$ = document.getElementById($AdfRichUIPeer$$.$createSubId$($component$$615_toolbarContainer$$1$$.$getClientId$(), $AdfToolbarPanel$$.$_TOOLBAR_CONTAINER_PLACEHOLDER_SUB_ID$));
  $toolbarPlaceholder$$ && ($component$$615_toolbarContainer$$1$$ = $AdfToolbarPanel$$.$_getToolbarContainer$($component$$615_toolbarContainer$$1$$), $toolbarPlaceholder$$.appendChild($component$$615_toolbarContainer$$1$$), $AdfAgent$$.$AGENT$.$removeBubbleEventListener$($component$$615_toolbarContainer$$1$$, "keydown", this.$_manageFocusCallback$));
};
$AdfObject$$.$exportPrototypeSymbol$("AdfToolbarPanel.prototype.detach", {detach:$AdfToolbarPanel$$.prototype.detach});
$AdfToolbarPanel$$.prototype.$handleKeyDown$ = function $$AdfToolbarPanel$$$$$handleKeyDown$$($componentEvent$$77$$, $contentNode$$21$$) {
  var $component$$inline_749_toolbarContainer$$inline_753$$ = this.$_peer$.$getComponent$(), $firstTabStop$$inline_754_keyCode$$inline_752$$ = $componentEvent$$77$$.$getKeyCode$(), $component$$inline_749_toolbarContainer$$inline_753$$ = $AdfToolbarPanel$$.$_getToolbarContainer$($component$$inline_749_toolbarContainer$$inline_753$$);
  $firstTabStop$$inline_754_keyCode$$inline_752$$ == $AdfKeyStroke$$.$TAB_KEY$ && $component$$inline_749_toolbarContainer$$inline_753$$ && $componentEvent$$77$$.$getNativeEventTarget$() == $contentNode$$21$$ && !$componentEvent$$77$$.$getNativeEvent$().shiftKey && ($firstTabStop$$inline_754_keyCode$$inline_752$$ = $AdfFocusUtils$$.$getFirstTabStop$($component$$inline_749_toolbarContainer$$inline_753$$)) && ($componentEvent$$77$$.cancel(), $AdfFocusUtils$$.$focusElement$($firstTabStop$$inline_754_keyCode$$inline_752$$));
};
$AdfObject$$.$exportPrototypeSymbol$("AdfToolbarPanel.prototype.handleKeyDown", {$handleKeyDown$:$AdfToolbarPanel$$.prototype.$handleKeyDown$});
$AdfToolbarPanel$$.$_getToolbarContainer$ = function $$AdfToolbarPanel$$$$_getToolbarContainer$$($clientId$$86_component$$616$$) {
  $clientId$$86_component$$616$$ = $clientId$$86_component$$616$$.$getClientId$();
  return document.getElementById($AdfRichUIPeer$$.$createSubId$($clientId$$86_component$$616$$, $AdfToolbarPanel$$.$_TOOLBAR_CONTAINER_SUB_ID$));
};
$AdfToolbarPanel$$.prototype.$_manageFocusInToolbarFacet$ = function $$AdfToolbarPanel$$$$$_manageFocusInToolbarFacet$$($event$$108$$) {
  var $peer$$74$$ = this.$_peer$, $component$$617$$ = $peer$$74$$.$getComponent$(), $contentNode$$22_firstTabStop$$2_keyCode$$26$$ = $AdfAgent$$.$AGENT$.$getKeyCode$($event$$108$$), $nextTabStop_toolbarContainer$$2$$ = $AdfToolbarPanel$$.$_getToolbarContainer$($component$$617$$);
  if ($nextTabStop_toolbarContainer$$2$$) {
    if ($contentNode$$22_firstTabStop$$2_keyCode$$26$$ == $AdfKeyStroke$$.$TAB_KEY$) {
      if ($contentNode$$22_firstTabStop$$2_keyCode$$26$$ = $AdfFocusUtils$$.$getFirstTabStop$($nextTabStop_toolbarContainer$$2$$), $nextTabStop_toolbarContainer$$2$$ = $AdfFocusUtils$$.$getNextTabStop$(document.activeElement), $event$$108$$.shiftKey ? $contentNode$$22_firstTabStop$$2_keyCode$$26$$ == document.activeElement : null == $nextTabStop_toolbarContainer$$2$$ || $nextTabStop_toolbarContainer$$2$$ == document.body) {
        $contentNode$$22_firstTabStop$$2_keyCode$$26$$ = $AdfDhtmlEditableValuePeer$$.$getContentNode$($component$$617$$, $peer$$74$$.$getDomElement$()), $event$$108$$.shiftKey ? $AdfFocusUtils$$.$focusElement$($contentNode$$22_firstTabStop$$2_keyCode$$26$$) : ($AdfFocusUtils$$.$focusNextTabStop$($contentNode$$22_firstTabStop$$2_keyCode$$26$$), $peer$$74$$.$RunValidation$($component$$617$$, $contentNode$$22_firstTabStop$$2_keyCode$$26$$, !0)), $AdfAgent$$.$AGENT$.$eatEvent$($event$$108$$);
      }
    } else {
      $contentNode$$22_firstTabStop$$2_keyCode$$26$$ == $AdfKeyStroke$$.$ARROWLEFT_KEY$ && ($contentNode$$22_firstTabStop$$2_keyCode$$26$$ = $AdfFocusUtils$$.$getFirstFocusableDescendant$($nextTabStop_toolbarContainer$$2$$), document.activeElement == $contentNode$$22_firstTabStop$$2_keyCode$$26$$ && $AdfAgent$$.$AGENT$.$eatEvent$($event$$108$$));
    }
  }
};
